<script setup lang="ts">
import { computed, ref } from "vue";
import ParameterResourceInput from "@/components/parameter-schema/form-mode/ParameterResourceInput.vue";
import ParameterNumberInput from "@/components/parameter-schema/form-mode/ParameterNumberInput.vue";
import ParameterBooleanInput from "@/components/parameter-schema/form-mode/ParameterBooleanInput.vue";
import ParameterEnumInput from "@/components/parameter-schema/form-mode/ParameterEnumInput.vue";
import ParameterFileInput from "@/components/parameter-schema/form-mode/ParameterFileInput.vue";
import ParameterStringInput from "@/components/parameter-schema/form-mode/ParameterStringInput.vue";
import type { SizeModifierType, ExtendedColors } from "@/types/PropTypes";
import ParameterMappingInput from "@/components/parameter-schema/form-mode/ParameterMappingInput.vue";
import ParameterTimeInput from "@/components/parameter-schema/form-mode/ParameterTimeInput.vue";

const model = defineModel({
  required: true,
});

const rawInput = ref<boolean>(false);
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

const props = defineProps<{
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  parameter: Record<string, any>;
  required?: boolean;
  resourceParameter?: boolean;
  sizeModifier?: SizeModifierType;
  border?: ExtendedColors;
  allowRaw?: boolean;
  forceRawFile?: boolean;
  mapping?: Record<string, string | number>;
  id?: string;
  customValidity?: string;
}>();

const parameterType = computed<string>(
  () => props.parameter["type"] ?? "string",
);

const elemId = computed<string>(() => props.id ?? randomIDSuffix);
const parameterFormat = computed<string | undefined>(
  () => props.parameter["format"],
);
const fileParameter = computed<boolean>(() => {
  return (
    parameterFormat.value != undefined &&
    (parameterFormat.value === "path" ||
      parameterFormat.value === "file-path" ||
      parameterFormat.value === "directory-path")
  );
});
const timeParameter = computed<boolean>(() => {
  return (
    parameterFormat.value != undefined &&
    (parameterFormat.value === "date" ||
      parameterFormat.value === "date-time" ||
      parameterFormat.value === "time")
  );
});
</script>

<template>
  <parameter-mapping-input
    v-if="mapping && Object.keys(mapping ?? {}).length > 0 && !rawInput"
    :id="elemId"
    v-model="model as string | number | undefined"
    :required="required"
    :size-modifier="sizeModifier"
    :border="border"
    :mapping="mapping"
    :allow-raw="allowRaw"
    :custom-validity="customValidity"
    @switch-to-raw="rawInput = true"
  />
  <parameter-number-input
    v-else-if="parameterType === 'number' || parameterType === 'integer'"
    :id="elemId"
    v-model="model"
    :parameter="parameter"
    :required="required"
    :size-modifier="sizeModifier"
    :border="border"
    :custom-validity="customValidity"
  />
  <parameter-boolean-input
    v-else-if="parameterType === 'boolean'"
    :id="elemId"
    v-model="model"
    :parameter="parameter"
    :border="border"
    :required="required"
    :custom-validity="customValidity"
  />
  <parameter-enum-input
    v-else-if="parameter['enum']"
    :id="elemId"
    v-model="model"
    :required="required"
    :parameter="parameter"
    :size-modifier="sizeModifier"
    :border="border"
    :custom-validity="customValidity"
  />
  <template v-else>
    <parameter-resource-input
      v-if="resourceParameter && !rawInput"
      :id="elemId"
      v-model="model"
      :parameter="parameter"
      :required="required"
      :size-modifier="sizeModifier"
      :border="border"
      :allow-raw="allowRaw"
      :custom-validity="customValidity"
      @switch-to-raw="rawInput = true"
    />
    <parameter-file-input
      v-else-if="fileParameter && !rawInput && !forceRawFile"
      :id="elemId"
      v-model="model"
      :required="required"
      :parameter="parameter"
      :size-modifier="sizeModifier"
      :border="border"
      :allow-raw="allowRaw"
      :custom-validity="customValidity"
      @switch-to-raw="rawInput = true"
    />
    <parameter-time-input
      v-else-if="timeParameter"
      :id="elemId"
      v-model="model"
      :parameter="parameter"
      :required="required"
      :size-modifier="sizeModifier"
      :border="border"
      :custom-validity="customValidity"
    />
    <parameter-string-input
      v-else
      :id="elemId"
      v-model="model"
      :parameter="parameter"
      :required="required"
      :size-modifier="sizeModifier"
      :border="border"
      :resource-parameter="resourceParameter"
      :allow-switch="allowRaw"
      :custom-validity="customValidity"
      @disable-raw="rawInput = false"
    />
  </template>
</template>

<style scoped></style>
